from ast import Global
from msilib.schema import tables
from operator import le
from pydoc import doc
import sys
import os
import re
from telnetlib import theNULL
import time
from enum import Enum
from xml.dom.expatbuilder import theDOMImplementation

OpenLog = True
GlobalPrint = print
filePath = "./"
configFile = "NeedProfileConfig.txt"
beginLine = "local startTime%s = os.clock()\n"
endLine = "print(LogType.Profiler, Display, \"[%s]time%s:\", (os.clock()-startTime%s)*1000)\n"
backUpPath = "BackUp"

def print(*args):
    if not OpenLog:
        return
    GlobalPrint(*args)

class ProfilerType(Enum):
    Default = 1
    Delete = 2
    Auto = 3
    SaveConfig = 4

class AutoProfiler:
    def __init__(self, profilerFile, profilerType):
        self.profilerFile = profilerFile
        self.profilerType = profilerType
        self.curConfilePath = filePath + configFile
        self.curBackUpPath = filePath + backUpPath
        print("[init]:",self.curConfilePath, self.curBackUpPath)

    # begin profiler
    def AutoProfiler(self):
        f = getattr(self, "DoProfilerType"+ str(self.profilerType.value), None)
        if f == None:
            return
        self.BackUpFile()
        f()

    def BackUpFile(self):
        if not os.path.exists(self.curBackUpPath):
            os.mkdir(self.curBackUpPath)
    
    # 删除埋点
    def DeleteAllProfiler(self):
        print("[AutoProfiler]DeleteAllProfiler")
        # backup file
        name = os.path.basename(self.profilerFile)
        nameArray = os.path.splitext(name)
        curTime = time.strftime("_%Y_%m_%d_%H_%M_%S", time.localtime())
        name = nameArray[0]+curTime+nameArray[1]

        profilerFo = open(self.profilerFile, "r+", encoding= "utf-8")
        profilerLines = profilerFo.readlines()
        with open(self.curBackUpPath+"/"+name, "w" , encoding= "utf-8") as newFile:
            newFile.writelines(profilerLines)
            newFile.flush()
            newFile.close()

        # modify profiler file
        profilerFo.seek(0)
        profilerFo.truncate(0)
        i = 0
        tempConf = {}
        hasDeleteRow = 0
        for line in profilerLines:
            i += 1
            searchObj = re.search( ".*startTime(\d*).*os.clock.*", line, re.M|re.I)
            if searchObj:
                beginIndex = searchObj.group(1)
                if not tempConf.get(beginIndex):
                    tempConf[beginIndex] = {}
                tempConf[beginIndex]["begin"] = i-hasDeleteRow
                hasDeleteRow +=1
                continue
            searchObj = re.search( ".*os.clock.*startTime(\d*).*", line, re.M|re.I)
            if searchObj:
                endIndex = searchObj.group(1)
                if not tempConf.get(endIndex):
                    tempConf[endIndex] = {}
                tempConf[endIndex]["end"] = i-hasDeleteRow - 1
                hasDeleteRow +=1
                continue
            profilerFo.write(line)
        profilerFo.flush()
        profilerFo.close()

        # save to config
        curConf = []
        for k in tempConf.keys():
            item = tempConf[k]
            begin = item.get("begin")
            end = item.get("end")
            if not begin:
                print("[DeleteAllProfiler] no begin")
                continue
            if not end:
                print("[DeleteAllProfiler] no end")
                continue
            curConf.append(str(begin)+" "+ str(end)+"\n")
        with open(self.curConfilePath, "r+", encoding= "utf-8") as confFo:
            confFo.seek(0)
            confFo.truncate(0)
            confFo.writelines(curConf)
            confFo.close()
        
    def AutoAnalyze(self):
        print("[AutoProfiler]AutoAnalyze, Do")
        profilerFo = open(self.profilerFile, "r+", encoding= "utf-8")
        profilerLines = profilerFo.readlines()
        i = 0
        config = []
        stack = []
        for line in profilerLines:
            line.replace("\n","")
            i += 1
            # method begin and end
            if re.match(" *print.*",line):
                # log print cant analyze
                continue
            if re.match(".*self.*\(.*\) *",line) or re.match(".* for .* do.* end *", line):
                config.append(str(i)+ " "+ str(i)+"\n")
                continue
            # loop begin and end
            if re.match(".*for .* do *",line):
                stack.append(["for", i])
                continue
            if re.match(".* if .* then *", line):
                stack.append(["if", i])
                continue
            if re.match(" *end *",line):
                if len(stack) != 0:
                    item = stack.pop()
                    if item[0] == "for":
                        config.append(str(item[1])+ " "+ str(i)+"\n")
        with open(self.curConfilePath, "r+", encoding= "utf-8") as configFile:
            configFile.seek(0)
            configFile.truncate(0)
            configFile.writelines(config)
            configFile.flush()
            configFile.close()
        self.ProfilerWithConfig()


    def ProfilerWithConfig(self):
        # open config
        confFo = open(self.curConfilePath, "r+", encoding= "utf-8")
        confLines = confFo.readlines()
        item = []
        for line in confLines:
                beginAndEnd = line.split(" ")
                item.append(beginAndEnd)

        # backup
        profilerFo = open(self.profilerFile, "r+", encoding= "utf-8")
        name = os.path.basename(self.profilerFile)
        nameArray = name.split(".")
        curTime = time.strftime("_%Y_%m_%d_%H_%M_%S", time.localtime())
        name = nameArray[0]+curTime+"."+nameArray[1]
        profilerLines = profilerFo.readlines()
        with open(self.curBackUpPath+"/"+name, "w" , encoding= "utf-8") as newFile:
            newFile.writelines(profilerLines)
            newFile.flush()
            newFile.close()

        # profiler
        fileName = nameArray[0]
        orLen = len(profilerLines)
        profilerLines[orLen-1] += "\n"
        lineIndex = list(range(orLen+1))
        newConfig = []
        print("[ProfilerWithConfig]config:",item)
        for i in range(0, len(item)):
            lineInfo = item[i]
            begin = int(lineInfo[0])-1
            end = int(lineInfo[1])
            # if begin > orLen or end > orLen:
            #     continue
            profilerLines.insert(lineIndex[end], endLine % (fileName , str(i), str(i)))
            newEnd = lineIndex[end]
            for j in range(end, orLen+1):
                lineIndex[j] = lineIndex[j] + 1
            profilerLines.insert(lineIndex[begin], beginLine % (str(i)))
            newBegin = lineIndex[begin]
            newEnd = newEnd +1
            for j in range(begin, orLen+1):
                lineIndex[j] = lineIndex[j] + 1

            #all different
            for config in newConfig:
                theBegin = config[0]
                theEnd = config[1]
                if theEnd < newBegin:
                    continue
                elif theBegin >= newBegin and theEnd<newEnd:
                    config[0] = config[0]+1
                    config[1] = config[1]+1
                elif theBegin >= newEnd:
                    config[0] = config[0]+2
                    config[1] = config[1]+2
                elif theBegin<newBegin and theEnd >= newEnd:
                    config[1] = config[1] + 2
                elif theBegin<newBegin and theEnd < newEnd:
                    config[1] = config[1] + 1
                elif theBegin>=newBegin and theEnd >= newEnd:
                    config[0] = config[0]+1
                    config[1] = config[1]+2
            newConfig.append([newBegin,newEnd])
        
        print("[ProfilerWithConfig]newConfig:", newConfig)
        newProfilerLineIndex = {}
        for config in newConfig:
            newProfilerLineIndex[config[0]] = True
            newProfilerLineIndex[config[1]] = True
            config.append(0)
            config.append(0)
        print("[ProfilerWithConfig]newProfilerLineIndex:", newProfilerLineIndex)
        # delete old profiler
        profilerFo.seek(0)
        profilerFo.truncate(0)
        i = 0
        for line in profilerLines:
            # 没有匹配到os.click或者是新写入的就写入文件
            if not re.match("(.*startTime.*os.clock.*)|(.*os.clock.*startTime.*)", line) or newProfilerLineIndex.get(i) == True:
                profilerFo.write(line)
            else: #这一行是需要删除的
                for config in newConfig:
                    theBegin = config[0]
                    theEnd = config[1]
                    if theBegin >= i:
                        config[2] +=1
                    if theEnd >= i:
                        config[3] +=1
            i = i +1
        profilerFo.flush()
        profilerFo.close()

        newWriteConfig =[]
        for lineInfo in newConfig:
            newWriteConfig.append(str(lineInfo[0]-lineInfo[2]+1)+ " "+ str(lineInfo[1]-lineInfo[3]+1)+"\n")
        # new config write back
        confFo.seek(0)
        confFo.truncate(0)
        confFo.writelines(newWriteConfig)
        confFo.flush()
        confFo.close()

    #将当前埋点存在配置文件中
    def AnalyzeToSaveProfiler(self):
        print("[AnalyzeToSaveProfiler]Do")
        profilerFo = open(self.profilerFile, "r+", encoding= "utf-8")
        profilerLines = profilerFo.readlines()
        profilerFo.close()
        config = {}
        i = 1
        for line in profilerLines:
            searchObj = re.search( ".*startTime(\d*).*os.clock.*", line, re.M|re.I)
            if searchObj:
                beginIndex = searchObj.group(1)
                if not config.get(beginIndex):
                    config[beginIndex] = {}
                config[beginIndex]["begin"] = i
                print("begin:", beginIndex)
            searchObj = re.search( ".*os.clock.*startTime(\d*).*", line, re.M|re.I)
            if searchObj:
                endIndex = searchObj.group(1)
                if not config.get(endIndex):
                    config[endIndex] = {}
                config[endIndex]["end"] = i
                print("end:", endIndex)
            i +=1
        curConf = []
        for k in config.keys():
            item = config[k]
            begin = item.get("begin")
            end = item.get("end")
            if not begin:
                print("[AnalyzeToSaveProfiler] no begin")
                continue
            if not end:
                print("[AnalyzeToSaveProfiler] no end")
                continue
            curConf.append(str(begin)+" "+ str(end)+"\n")

        confFo = open(self.curConfilePath, "r+", encoding= "utf-8")
        confFo.seek(0)
        confFo.truncate(0)
        confFo.writelines(curConf)
        confFo.close()


    def BatchProfilerWithConfig(self):
        #解析文件
        fileArr = []
        confFo = open(self.curConfilePath, "r", encoding= "utf-8")
        confLines = confFo.readlines()
        item = None
        for line in confLines:
            line = line.replace("\n", "")
            if line.endswith(".lua"):
                item = []
                item.append(line)
                fileArr.append(item)
            else:
                beginAndEnd = line.split(" ")
                item.append(beginAndEnd)
        confFo.close()
        for fileItem in fileArr:
            #名字
            fileName = os.path.basename(fileItem[0]).split('.')[0]
            fo = open(fileItem[0], "r+", encoding= "utf-8")
            curLines = fo.readlines()
            orLen = len(curLines)
            lineIndex = list(range(orLen))
            for i in range(1, len(fileItem)):
                lineInfo = fileItem[i]
                begin = int(lineInfo[0])
                end = int(lineInfo[1])
                curLines.insert(lineIndex[end], endLine % (fileName + str(i)))
                for j in range(end, orLen):
                    lineIndex[j] = lineIndex[j] + 1
                curLines.insert(lineIndex[begin - 1], beginLine % (fileName + str(i)))
                for j in range(begin - 1, orLen):
                    lineIndex[j] = lineIndex[j] + 1
            fo.seek(0)
            fo.writelines(curLines)
            fo.flush()
            fo.close()

    def DoProfilerType1(self):
        print("[AutoProfiler]DoProfilerType default")
        self.ProfilerWithConfig()
        print("[AutoProfiler]DoProfilerType default Finish")
        pass

    def DoProfilerType2(self):
        print("[AutoProfiler]DoProfilerType delete")
        self.DeleteAllProfiler()
        print("[AutoProfiler]DoProfilerType delete Finish")

    def DoProfilerType3(self):
        print("[AutoProfiler]DoProfilerType auto")
        self.DeleteAllProfiler()
        self.AutoAnalyze()
        print("[AutoProfiler]DoProfilerType auto Finish")

    def DoProfilerType4(self):
        print("[AutoProfiler]DoProfilerType SaveConfig")
        self.AnalyzeToSaveProfiler()  
        print("[AutoProfiler]DoProfilerType SaveConfig Finsh")  


if __name__ == '__main__':
    argvLen = len(sys.argv)
    if argvLen < 2:
        print("param num error")
    else:
        # file = sys.argv[1]
        profilerFile = sys.argv[1]
        if not profilerFile.endswith("lua"):
            print("select file is not lua file")
        else:
            profilerType = ProfilerType.Default
            if argvLen >2:
                profilerType = ProfilerType(int(sys.argv[2]))
            if argvLen > 3:
                filePath = sys.argv[3]
            print(profilerFile, ", ",profilerType)
            autoProfiler = AutoProfiler(profilerFile ,profilerType)
            autoProfiler.AutoProfiler()


